#tag Class
Protected Class pcmPieChart
Inherits Canvas
	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  Return True
		  
		End Function
	#tag EndEvent

	#tag Event
		Sub MouseUp(X As Integer, Y As Integer)
		  CurrentPointX = X
		  CurrentPointY = Y
		  
		  Me.Invalidate
		End Sub
	#tag EndEvent

	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  Dim centerX As Double = Me.Width / 2
		  Dim centerY As Double = Me.Width / 2
		  Dim radius As Double = Me.Width
		  
		  Dim a As ArcShape
		  
		  Dim s As String
		  
		    
		  Dim pieData() As String = Split(mData,",")
		  
		  
		  Dim data_sum As Double // Gesamtsumme
		  For Each d As String In pieData // Alle Werte zur Gestamsumme berechnen
		    data_sum = data_sum + Val(d)
		  Next
		  
		  Dim umfang As Double = 2 * kPi / data_sum // Umfang aus Gesamtsumme berechnen
		  Dim next_data As Double = 0
		  
		  'System.DebugLog "data_sum: " + Str(data_sum) + "(" + Str(umfang) + ")"
		  
		  For i As Integer = 0 To UBound(pieData)
		    
		    a = New ArcShape
		    a.Width = radius
		    a.Height = radius
		    a.FillColor = GetRandomColor  // Zufallsfarbe
		    a.StartAngle = next_data // Starte bei 0 und danach nach jedem Wert
		    a.ArcAngle = umfang * Val(pieData(i)) // Größe anhand eines Wertes
		    next_data = next_data + umfang * Val(pieData(i)) // Werte zusammenrechnen um den nächsten Startwert zu erhalten
		    g.DrawObject (a, centerx, centerY)
		    
		    System.DebugLog "data "+ Str(i) + ": " + Str(umfang * Val(pieData(i)))
		    
		    System.DebugLog "Koordinaten (X/Y) " + Str(i) + ": " + Str(umfang * Val(pieData(i)) * radius) 
		    
		    If CurrentPointX > 0 Then g.DrawString(s,CurrentPointX, CurrentPointY)
		    
		  Next i
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h21
		Private Function GetRandomColor() As Color
		  // Erstelle eine Zufalssfarbe, Dazu ist es wichtig color als Variant zu defnieren
		  
		  Dim letters As String = "0123456789ABCDEF"
		  Dim color As Variant = "&c"
		  Dim r As New Random
		  
		  For i As Integer = 1 to 6
		    color = color + letters.Mid(r.InRange(1,16),1)
		  Next i
		  
		  Return Color
		End Function
	#tag EndMethod


	#tag Property, Flags = &h21
		Private CurrentPointX As Integer = -1
	#tag EndProperty

	#tag Property, Flags = &h21
		Private CurrentPointY As Integer = -1
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  return mData
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  mData = value
			  
			  Self.Refresh(false)
			End Set
		#tag EndSetter
		Data As String
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private mData As String
	#tag EndProperty


	#tag Constant, Name = kPi, Type = Double, Dynamic = False, Default = \"3.14159265358979323846264338327950", Scope = Private
	#tag EndConstant


	#tag ViewBehavior
		#tag ViewProperty
			Name="AcceptFocus"
			Visible=true
			Group="Behavior"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="AcceptTabs"
			Visible=true
			Group="Behavior"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="AutoDeactivate"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Backdrop"
			Visible=true
			Group="Appearance"
			Type="Picture"
			EditorType="Picture"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Data"
			Visible=true
			Group="Behavior"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="DoubleBuffer"
			Visible=true
			Group="Behavior"
			InitialValue="False"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Enabled"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="EraseBackground"
			Visible=true
			Group="Behavior"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Height"
			Visible=true
			Group="Position"
			InitialValue="100"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="HelpTag"
			Visible=true
			Group="Appearance"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			Type="Integer"
			EditorType="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="InitialParent"
			Group="Position"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockBottom"
			Visible=true
			Group="Position"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockLeft"
			Visible=true
			Group="Position"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockRight"
			Visible=true
			Group="Position"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockTop"
			Visible=true
			Group="Position"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
			EditorType="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
			EditorType="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabIndex"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabPanelIndex"
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabStop"
			Visible=true
			Group="Position"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Transparent"
			Visible=true
			Group="Behavior"
			InitialValue="True"
			Type="Boolean"
			EditorType="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="UseFocusRing"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Visible"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Width"
			Visible=true
			Group="Position"
			InitialValue="100"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
